//==========================================================================
// Main.cpp
//   ߂[
//==========================================================================

#include "StdAfx.h"
#include "Util.h"
#include "Resource.h"
#include "..\Dll\MouseHookDLL.h"
#include "TrayIcon.h"
#include "FoldableWindow.h"
#include "WindowBacking.h"
using namespace MouseHookDLL;



//-----------------------------------------------------------------------
// G[
//-----------------------------------------------------------------------

void report_error( UINT id )
{
	::MessageBox( NULL,
		load_string(id).c_str(), load_string(IDS_APP_TITLE).c_str(), MB_OK|MB_ICONINFORMATION );
}

//-----------------------------------------------------------------------
// }EXCxgǐ
//-----------------------------------------------------------------------

class MouseTracer
	: public MouseHookHandler
	, msg_receiver
{
public: // EI

	MouseTracer()
		:  isLeftButtonDown( false )
		, isRightButtonDown( false )
	{
		::InitializeCriticalSection( &cs );
		::MouseHookBegin( this );
	}

	~MouseTracer()
	{
		::MouseHookEnd();
		::DeleteCriticalSection(&cs);
	}

private: // }EX݈̌ʒuXbhZ[tɕێ

	CRITICAL_SECTION cs;
	dcomp currentMousePosition; // do NOT directly read this var!

	dcomp getMousePt()
	{
		::EnterCriticalSection(&cs);
		dcomp pt = currentMousePosition;
		::LeaveCriticalSection(&cs);
		return pt;
	}

	void updateMousePt( dcomp pt )
	{
		::EnterCriticalSection(&cs);
		currentMousePosition = pt;
		::LeaveCriticalSection(&cs);
	}

private: // ჌x}EXCxg₷`ɕϊ

	bool isLeftButtonDown, isRightButtonDown;
	inline bool isMouseDown() { return isLeftButtonDown||isRightButtonDown; }

	virtual void on_mouse_event( UINT cmd, MSLLHOOKSTRUCT* dat )
	{
		const bool wasMouseDown = isMouseDown();

		// ԍXV
		updateMousePt( dcomp(dat->pt.x,dat->pt.y) );
		switch( cmd )
		{
		case WM_LBUTTONUP:    isLeftButtonDown = false; break;
		case WM_RBUTTONUP:   isRightButtonDown = false; break;
		case WM_LBUTTONDOWN:  isLeftButtonDown = true;  break;
		case WM_RBUTTONDOWN: isRightButtonDown = true;  break;
		case WM_MOUSEMOVE: break;
		}

		// CxgMi}EXJn or hbO or }EXIj
		if( !wasMouseDown &&  isMouseDown() ) fire( MOUSE_DOWN );
		if(  wasMouseDown &&  isMouseDown() ) fire( DRAG_MOVE );
		if(  wasMouseDown && !isMouseDown() ) fire( MOUSE_UP );
	}

	// postMessageŎɓBon_mouse_eventłɏsȂ̂́A
	// on_mouse_eventHook֐Ȃ̂ŁA"Ԃ̂鏈͔"̂
	// "CXbhƂ͕ʃXbhȂ̂œƂ̂FX₱"̂̓̗RB
	enum EventID { MOUSE_DOWN, MOUSE_UP, DRAG_MOVE, EV_END };
	void fire( EventID v ) { postMessage(WM_USER+v); }

	virtual LRESULT on_message( UINT msg, WPARAM wp, LPARAM lp )
	{
		if( WM_USER<=msg && msg<WM_USER+EV_END )
			switch(msg-WM_USER)
			{
			case MOUSE_DOWN: event_mouse_down(); return 0;
			case DRAG_MOVE : event_drag_move();  return 0;
			case MOUSE_UP  : event_mouse_up();   return 0;
			}
		return msg_receiver::on_message( msg, wp, lp );
	}

private: // }EXHhbOH ւ̕ϊ

	bool  isFirstMoveAfterTheMouseDown;
	dcomp prevMousePt;

	vector<FoldableWindow> foldwnd;
	WindowBacking          backing;

	void event_mouse_down()
	{
		if( ! foldwnd.empty() )
			return;

		// NbNhbO킩̂ŁA܂Ȃ
		isFirstMoveAfterTheMouseDown = true;
		prevMousePt = getMousePt();
	}

	void event_drag_move()
	{
		dcomp mousePt = getMousePt();

		if( isFirstMoveAfterTheMouseDown )
		{
			isFirstMoveAfterTheMouseDown = false;

			// {^ԂŃ}EXʒun߂chbOJnI
			doDragBegin( mousePt );
		}

		if( foldwnd.empty() || prevMousePt==mousePt )
			return;

		// hbOpc
		doDragContinue( prevMousePt, mousePt );
		prevMousePt = mousePt;
	}

	void event_mouse_up()
	{
		// (KvȂ)hbOI
		isFirstMoveAfterTheMouseDown = false;
		if( ! foldwnd.empty() )
		{
			backing.dragEnd();
			foldwnd.clear();
		}
	}

private: // C

	void doDragBegin( const dcomp& pt )
	{
		// 1: ŏʃEChE
		TopLevelWindowList hwnds;
		if( hwnds.empty() )
			return; // 1Ȃ[

		// 2: GbW߂drag͐܂Ȃ[hJnȂ
		//   i^Cgo[hbOetc͔̎Ȃ]܂j
		POINT ptx = {long(pt.real()), long(pt.imag())};
		int cutLen = ::GetSystemMetrics(SM_CYCAPTION) + ::GetSystemMetrics(SM_CYFRAME);
		for(int i=0; i!=hwnds.size(); ++i)
		{
			RECT rc; ::GetWindowRect( hwnds[i], &rc );
			if( ::PtInRect(&rc, ptx) )
			{
				::InflateRect( &rc, -cutLen, -cutLen );
				if( !::PtInRect(&rc, ptx) )
					return;
				break;
			}
		}

		// 3: nEChE܂ȂԂEChEJn
		backing.dragBegin();
		foldwnd.resize( hwnds.size() );
		for(int i=foldwnd.size()-1; i>=0; --i)
			foldwnd[i].Init( hwnds[i] );
	}

	void doDragContinue( const dcomp& prev, const dcomp& pt )
	{
		vector<bool> updated( foldwnd.size(), false );

		// 1: ɂ鑋珇Ƀ}EXCxgMBȂ肷B
		bool no_mekuri = false;
		for(int i=0; i!=foldwnd.size(); ++i)
		{
			if( no_mekuri && foldwnd[i].is_taira() )
				continue;
			if( foldwnd[i].mouse( prev, pt ) )
				updated[i] = true;
			else if( !no_mekuri && foldwnd[i].covers(pt) )
				no_mekuri = true; // ȏ̑͌ĂȂ̂ŋȂȂ
		}

		// 2: Đ܂ȂBɂ鑋珇ɁȂċȂ肷B
		for(int i=foldwnd.size()-1; i>=0; --i)
			if( updated[i] )
			{
				dcomp c1, c2;
				if( foldwnd[i].get_orime(c1,c2) )
					for(int j=i-1; j>=0; --j)
						if( foldwnd[j].rebend(c1,c2) )
							updated[j] = true;
			}

		// 3: ܂Ƃ߂Č`ό`Ȃ
		// 3-1: Window̌`Aň`W`
		// 3-2: nɃR~bg(backing.renderEnd)
		backing.renderBegin();
		for(int i=0; i!=foldwnd.size(); ++i)
			foldwnd[i].updateShape( backing, updated[i] );
		backing.renderEnd();
	}


public:// test
	void config_setBackingDefault()
	{
		backing.setRenderer<WindowBackingRenderer_Default>();
	}
	void config_setBackingColor( COLORREF rgb )
	{
		backing.setRenderer<WindowBackingRenderer_SingleColor>( rgb );
	}
	void config_setBackingPicture( const tstring& filename )
	{
		backing.setRenderer<WindowBackingRenderer_Picture>( filename );
	}
};

//-----------------------------------------------------------------------
// ݒ_CAO
//-----------------------------------------------------------------------

// ToDo
class ConfigDlg
{
	MouseTracer* mt;

	struct Config
	{
		Config() : mode(0), rgb(RGB(255,0,0)) {}
		int      mode;
		COLORREF rgb;
		tstring  pictfile;
	};
	Config cur, tmp;
	HBRUSH colorBrush;

	void getFromDlg( HWND dlg )
	{
		if( ::IsDlgButtonChecked(dlg, IDC_BGMODE3) )
			tmp.mode = 2;
		else if( ::IsDlgButtonChecked(dlg, IDC_BGMODE2) )
			tmp.mode = 1;
		else
			tmp.mode = 0;

		TCHAR buf[MAX_PATH];
		::GetDlgItemText(dlg, IDC_BGFILE_NAME, buf, lengthof(buf));
		tmp.pictfile = buf;

		::DeleteObject( colorBrush );
		colorBrush = ::CreateSolidBrush( tmp.rgb );
	}
	void setToExecuter()
	{
		if( cur.mode == 0 ) mt->config_setBackingDefault();
		if( cur.mode == 1 ) mt->config_setBackingColor( cur.rgb );
		if( cur.mode == 2 ) mt->config_setBackingPicture( cur.pictfile );
	}


public:
	ConfigDlg(MouseTracer* mt) : mt(mt)
	{
		// init@C
		TCHAR iniName[MAX_PATH];
		::GetModuleFileName( NULL, iniName, lengthof(iniName) );
		size_t len = _tcslen(iniName);
		iniName[len-3] = TEXT('i');
		iniName[len-2] = TEXT('n');
		iniName[len-1] = TEXT('i');

		// [U
		TCHAR userName[UNLEN+1] = TEXT("default");
		DWORD siz = lengthof(userName);
		::GetUserName(userName, &siz);

		// [
		cur.mode =
		::GetPrivateProfileInt   ( userName, TEXT("mode"), 0,                iniName );
		cur.rgb =
		::GetPrivateProfileInt   ( userName, TEXT("rgb") , RGB(128,128,128), iniName );
		TCHAR buf[MAX_PATH];
		::GetPrivateProfileString( userName, TEXT("pict"), TEXT(""), buf, lengthof(buf), iniName );
		cur.pictfile = buf;

		// ݒ
		setToExecuter();
	}
	~ConfigDlg()
	{
		// init@C
		TCHAR iniName[MAX_PATH];
		::GetModuleFileName( NULL, iniName, lengthof(iniName) );
		size_t len = _tcslen(iniName);
		iniName[len-3] = TEXT('i');
		iniName[len-2] = TEXT('n');
		iniName[len-1] = TEXT('i');

		// [U
		TCHAR userName[UNLEN+1] = TEXT("default");
		DWORD siz = lengthof(userName);
		::GetUserName(userName, &siz);

		// Z[u
		TCHAR buf[200];
		wsprintf( buf, TEXT("%d"), cur.mode );
		::WritePrivateProfileString( userName, TEXT("mode"), buf, iniName );
		wsprintf( buf, TEXT("%d"), cur.rgb );
		::WritePrivateProfileString( userName, TEXT("rgb") , buf, iniName );
		::WritePrivateProfileString( userName, TEXT("pict"), cur.pictfile.c_str(), iniName );
	}

	void doDialog()
	{
		tmp = cur;
		colorBrush = ::CreateSolidBrush( tmp.rgb );
		if( IDOK == ::DialogBoxParam(
			current_module(), MAKEINTRESOURCE(IDD_CONFIG), NULL,
			&DlgProc, reinterpret_cast<LPARAM>(this) ) )
		{
			cur = tmp;
			setToExecuter();
		}
		::DeleteObject( colorBrush );
	}

private:
	BOOL on_message( HWND dlg, UINT msg, WPARAM wp, LPARAM lp )
	{
		if( msg == WM_INITDIALOG )
		{
			::CheckDlgButton(dlg, IDC_BGMODE1+tmp.mode, BST_CHECKED);
			TCHAR buf[40];
			::PathCompactPathEx( buf, tmp.pictfile.c_str(), lengthof(buf), 0 );
			::SetDlgItemText(dlg, IDC_BGFILE_NAME, buf);
		}
		else if( msg == WM_CTLCOLORSTATIC )
		{
			if( lp == reinterpret_cast<LPARAM>(::GetDlgItem(dlg,IDC_BGCOLOR)) ) {
				return reinterpret_cast<BOOL>(colorBrush);
			}
		}
		else if( msg == WM_COMMAND )
		{
			if( LOWORD(wp) == IDCANCEL )
			{
				::EndDialog( dlg, IDCANCEL );
				return true;
			}
			else if( LOWORD(wp) == IDOK )
			{
				if( ::IsDlgButtonChecked(dlg, IDC_BGMODE3) )      tmp.mode = 2;
				else if( ::IsDlgButtonChecked(dlg, IDC_BGMODE2) ) tmp.mode = 1;
				else                                              tmp.mode = 0;
				::EndDialog( dlg, IDOK );
				return true;
			}
			else if( LOWORD(wp) == IDC_BGCOLOR )
			{
				static COLORREF custs[16];
				CHOOSECOLOR cc = {sizeof(cc), dlg, NULL, tmp.rgb, custs,
					CC_ANYCOLOR|CC_FULLOPEN|CC_RGBINIT };
				if( ::ChooseColor( &cc ) )
				{
					::CheckDlgButton(dlg, IDC_BGMODE1, BST_UNCHECKED);
					::CheckDlgButton(dlg, IDC_BGMODE2, BST_CHECKED);
					::CheckDlgButton(dlg, IDC_BGMODE3, BST_UNCHECKED);

					tmp.rgb = cc.rgbResult;
					::DeleteObject( colorBrush );
					colorBrush = ::CreateSolidBrush( tmp.rgb );
					::InvalidateRect( ::GetDlgItem(dlg,IDC_BGCOLOR), NULL, TRUE );
					::UpdateWindow( ::GetDlgItem(dlg,IDC_BGCOLOR) );
				}
				return true;
			}
			else if( LOWORD(wp) == IDC_BGFILE_REF )
			{
				TCHAR namebuf[MAX_PATH];
				_tcscpy( namebuf, tmp.pictfile.c_str() );

				tstring name = load_string(IDS_PICTFILTER);

				OPENFILENAME ofn = {sizeof(ofn), dlg, NULL,
					name.c_str(), NULL, NULL, 0,
					namebuf, lengthof(namebuf), NULL, 0, NULL, NULL,
					OFN_DONTADDTORECENT|OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_LONGNAMES|OFN_PATHMUSTEXIST };
				if( ::GetOpenFileName( &ofn ) )
				{
					::CheckDlgButton(dlg, IDC_BGMODE1, BST_UNCHECKED);
					::CheckDlgButton(dlg, IDC_BGMODE2, BST_UNCHECKED);
					::CheckDlgButton(dlg, IDC_BGMODE3, BST_CHECKED);

					tmp.pictfile = ofn.lpstrFile;
					TCHAR buf[40];
					::PathCompactPathEx( buf, ofn.lpstrFile, lengthof(buf), 0 );
					::SetDlgItemText(dlg, IDC_BGFILE_NAME, buf);
				}
				return true;
			}
		}
		return false;
	}

	static INT_PTR CALLBACK DlgProc( HWND dlg, UINT msg, WPARAM wp, LPARAM lp )
	{
		if( msg == WM_INITDIALOG )
		{
			move_center_relative_to( dlg );
			::SetWindowLongPtr( dlg, GWLP_USERDATA, lp );
		}
		LONG_PTR ptr = ::GetWindowLongPtr(dlg, GWLP_USERDATA);
		return ptr==0 ? 0 :
			reinterpret_cast<ConfigDlg*>(::GetWindowLongPtr(dlg,GWLP_USERDATA))
				->on_message( dlg, msg, wp, lp );
	}
};

//-----------------------------------------------------------------------
// gCj[
//-----------------------------------------------------------------------

class OriMadoMenu : public TrayIconEventHandler
{
	ConfigDlg* dlg;
public:
	OriMadoMenu(ConfigDlg* dlg) : menu( load_menu(IDM_MAINMENU) ), dlg(dlg), dlging(false) {}
	~OriMadoMenu() { ::DestroyMenu( menu ); }

private:
	const HMENU menu;
	bool dlging;
	virtual HMENU on_menu() {
		HMENU m = ::GetSubMenu( menu, 0 );
		::EnableMenuItem( m, ID_CMD_CONFIG, MF_BYCOMMAND|(dlging?MF_GRAYED:MF_ENABLED) );
		return m;
	}
	virtual void  on_command( HMENU, UINT id )
	{
		switch( id )
		{
		case ID_CMD_CONFIG:
			dlging = true;
			dlg->doDialog();
			dlging = false;
			break;
		case ID_CMD_EXIT:
			::PostQuitMessage( 0 );
			break;
		}
	}
};

//-----------------------------------------------------------------------
// C[v
//-----------------------------------------------------------------------

int APIENTRY WinMain( HINSTANCE, HINSTANCE, LPSTR, int )
{
	try
	{
		// dNh~̏u
		deny_multi_boot dmb( TEXT("OriMado_Mutex_DenyMultiBoot") );

		// }EXĎX^[gI
		MouseTracer mt;
		ConfigDlg dlg(&mt);

		// ^XNgCɏ풓X^[gI
		OriMadoMenu menu(&dlg);
		TrayIcon tsi( &menu, load_string(IDS_APP_TITLE).c_str() );
		tsi.setIcon( load_icon(IDI_MAINICON) );
		tsi.setTip ( load_string(IDS_APP_TITLE) );

		// T^IbZ[W[vI
		for( MSG msg; ::GetMessage(&msg,NULL,0,0); )
		{
			::TranslateMessage( &msg );
			::DispatchMessage( &msg );
		}
	}
	catch( deny_multi_boot::exception& )
	{
		report_error( IDS_ERR_DENYMULTIBOOT );
	}
}
