//==========================================================================
// TrayIcon.cpp
//   ^XNo[̃gCɃACRi[@\
//==========================================================================

#include "StdAfx.h"
#include "Util.h"
#include "TrayIcon.h"

TrayIcon::TrayIcon( TrayIconEventHandler* evhan, const TCHAR* dummyWndName )
	: msg_receiver( dummyWndName )
	,        evhan( evhan )
{
	// p[^ݒ
	config.cbSize           = sizeof(config);
	config.hWnd             = wnd_handle();
	config.uID              = 0x17871787; // ĂƁ[Ȕԍ
	config.uFlags           = NIF_MESSAGE | NIM_SETVERSION;
	config.uCallbackMessage = getStdNotifyMsg();
	config.uVersion         = NOTIFYICON_VERSION;

	// gCɒǉI
	send_ADD();
	send_SETVERSION();
}

TrayIcon::~TrayIcon()
{
	// gC폜
	send_DELETE();
}

bool TrayIcon::send_ADD()
	{ return to_bool(::Shell_NotifyIcon( NIM_ADD,    &config )); }
bool TrayIcon::send_MODIFY()
	{ return to_bool(::Shell_NotifyIcon( NIM_MODIFY, &config )); }
bool TrayIcon::send_DELETE()
	{ return to_bool(::Shell_NotifyIcon( NIM_DELETE, &config )); }
bool TrayIcon::send_SETVERSION()
	{ return to_bool(::Shell_NotifyIcon( NIM_SETVERSION, &config )); }

void TrayIcon::readd()
{
	send_ADD();
	send_SETVERSION();
}

void TrayIcon::setIcon( HICON icn )
{
	config.uFlags |= NIF_ICON;
	config.hIcon   = icn;
	send_MODIFY();
}

void TrayIcon::setTip( tstring str )
{
	config.uFlags |= NIF_TIP;

	if( str.size() >= lengthof(config.szTip) )
	{
		// ꍇ͖ ... ɂ
		str.resize( lengthof(config.szTip)-4 );
		str += TEXT("...");
	}
	copy( str.begin(), str.end(), &config.szTip[0] );
	config.szTip[str.size()] = TEXT('\0');
	send_MODIFY();
}

UINT TrayIcon::getTaskbarCreatedMsg()
{
	// ExplorerčċN肵ă^XNo[ēxꂽ
	// ł郁bZ[W
	static UINT msg = ::RegisterWindowMessage( TEXT("TaskbarCreated") );
	return msg;
}

UINT TrayIcon::getStdNotifyMsg()
{
	// gCACRŋNCxgłƂɎgp
	// bZ[Wo^Ă
	static UINT msg = ::RegisterWindowMessage( TEXT("kilib_trayicon_stdnotifmsg") );
	return msg;
}

LRESULT TrayIcon::on_message( UINT msg, WPARAM wp, LPARAM lp )
{
	if( msg == getTaskbarCreatedMsg() )
	{
		// Ēǉ
		readd();
		return 0;
	}

	if( msg == getStdNotifyMsg() )
	{
		// j[o
		switch( lp )
		{
		case NIN_KEYSELECT :
		case NIN_SELECT    :
		case WM_CONTEXTMENU:
			if( HMENU menu = evhan->on_menu() )
			{
				POINT pt;
				::GetCursorPos( &pt );

				// gC TrackPopupMenu ́A
				//  SetForegroundWindow -> TrackPopupMenu -> WM_NULL 
				// ȂƉ̂܂Ȃ炵B
				::SetForegroundWindow( wnd_handle() );
				UINT id =
					::TrackPopupMenu(
						menu, TPM_LEFTALIGN|TPM_RIGHTBUTTON|TPM_RETURNCMD,
						pt.x, pt.y, 0, wnd_handle(), NULL );
				::PostMessage( wnd_handle(), WM_NULL, 0, 0 );

				// IĂR}hM
				if( id )
					evhan->on_command( menu, id );
			}
			break;
		}
		return 0;
	}

	return msg_receiver::on_message( msg, wp, lp );
}
