#pragma once
//==========================================================================
// WindowBacking.h
//   ܂Ȃ\EChE̗n̏낢
//==========================================================================

class FoldedRect;



//
// ̗n̕`揈SNX̃C^[tFCX
//

class WindowBackingRenderer
{
	friend class WindowBacking;

	// 
	// virtual constructor( HWND wnd, ... );

	// `Xe[gǗ
	virtual void renderBegin()                           {}
	virtual void renderOneWindow( const FoldedRect& fr ) {}
	virtual void renderEnd()                             {}

	// EChEYECxg
	virtual void on_display_size_change( HWND wnd ) {}
	virtual bool on_erase_background( HWND wnd, HDC dc ) { return true; }//VXeɔwiȂfalse
	virtual void on_paint( HWND wnd, HDC dc ) {}

protected:
	virtual ~WindowBackingRenderer() {}
};



//
// Ȃ_
//

class WindowBackingRenderer_Default
	: public WindowBackingRenderer
{
	virtual bool on_erase_background( HWND wnd, HDC dc ) { return false; }

public:
	WindowBackingRenderer_Default( HWND ) {}
};


//
// PFhԂ
//

class WindowBackingRenderer_SingleColor
	: public WindowBackingRenderer
{
	HBRUSH brush;
	virtual void on_paint( HWND wnd, HDC dc );

public:
	WindowBackingRenderer_SingleColor( HWND, COLORREF color );
	virtual ~WindowBackingRenderer_SingleColor();
};



//
// 摜`i݂̎ł́ADirect3Dgp܂j
//

class WindowBackingRenderer_Picture
	: public WindowBackingRenderer
{
	IDirect3DDevice8*  direct3DDevice;
	IDirect3DTexture8* texture;
	virtual void renderBegin();
	virtual void renderOneWindow( const FoldedRect& fr );
	virtual void renderEnd();
	virtual void on_display_size_change( HWND wnd );
	virtual void on_paint( HWND wnd, HDC dc );

public:
	WindowBackingRenderer_Picture( HWND wnd, const tstring& pictFile );
	virtual ~WindowBackingRenderer_Picture();
};



//
// ̗nǗS
//

class WindowBacking
	: noncopyable
{
public:
	WindowBacking();
	~WindowBacking();
	static const TCHAR* getWindowClass();

public:
	void dragBegin();
	void dragEnd();

public:
	template<typename RendererT>
	  void setRenderer()
	    { renderer = shared_ptr<WindowBackingRenderer>(new RendererT(wnd)); }
	template<typename RendererT, typename ParamT>
	  void setRenderer( const ParamT& p )
	    { renderer = shared_ptr<WindowBackingRenderer>(new RendererT(wnd,p)); }
	void renderBegin();
	void renderOneWindow( const FoldedRect& fr, HRGN original_rgn );
	void renderEnd();

private:
	static LRESULT CALLBACK WndProc( HWND wnd, UINT msg, WPARAM wp, LPARAM lp );

	const HWND                        wnd;
	shared_ptr<WindowBackingRenderer> renderer;

	HRGN rgn_holder;
	bool first_render;
	int  render_count;
};
